<?php
/**
 * $Horde: passwd/lib/Driver/ctrlclnt.php, v 1.0 2003/08/15 ericr Exp $
 *
 * The ctrlclnt class attempts to change a user's password on a XMail server.
 *
 * @author   Leonardo Fogel <leonardofogel@yahoo.com.br>
 * @package  passwd
 */

class Passwd_Driver_ctrlclnt extends Passwd_Driver
{
    /** Hash containing connection parameters. */
    var $_params;

    /**
     * Constructs a new ctrlclnt Passwd_Driver object.
     *
     * @param array  $params    A hash containing connection parameters.
     */
    function Passwd_Driver_ctrlclnt($params = array())
    {
        $this->_params = $params;
    }

    /**
     * Change the user's password.
     *
     * @return  boolean         True or false based on success of the change.
     */
    function change_password($username,  $oldpassword, $newpassword)
    {

        $user = escapeshellarg($username);
        $oldpass = escapeshellarg($oldpassword);
        $newpass = escapeshellarg($newpassword);

        if (!( array_key_exists("program", $this->_params)
            && array_key_exists("host", $this->_params)
            && array_key_exists("user", $this->_params)
            && array_key_exists("password", $this->_params)
            && array_key_exists("domain", $this->_params)) )
            return PEAR::raiseError(_("Password module is not properly configured"));

        $base_cmd = $this->_params['program']
            . " -s " . $this->_params['host']
            . " -u " . $this->_params['user']
            . " -p " . $this->_params['password'];

        $auth_cmd = $base_cmd
            . " " . "userauth"
            . " " . $this->_params['domain']
            . " " . $user
            . " " . $oldpass;

        $pass_cmd = $base_cmd
            . " " . "userpasswd"
            . " " . $this->_params['domain']
            . " " . $user
            . " " . $newpass;

        /** Authenticate the user */
        system($auth_cmd, $ret);
        if ($ret != 0)
            return PEAR::raiseError(_("Incorrect user or password"));

        /** Change the user's password */
        system($pass_cmd, $ret);
        if ($ret != 0)
            return PEAR::raiseError(_("Internal Error"));

        $this->reset_credentials($username, $oldpassword, $newpassword);
        return true;
    }
}
